(
-- to do: light and shader subdivs heuristics based on glossiness/area
-- changes: DR, Max ray intensity left alone -- DONE
-- Checkbox for VFB operations 	DONE
--Additions: controls for LC sample rate and size,  DONE
-- Add LC subdivs and original sample size in the info panel - DONE
-- Add tooltips - DONE
-- Split the Archviz preset two one with low and one with high camera rays - NOT YET
-- show renderers.current
	
	global vr3rpRoll
	try (destroyDialog vr3rpRoll) catch()
	
	local lf=filein @"lelesFnsStructFile_v1.50.ms"
	local cr,wasRR
	local minRPP=maxRPP=lightsMinRPP=lightsMaxRPP=minShCPP=maxShCPP=minLtCPP=maxLtCPP=SSSRPP=GIRPP=minSSSRPP=maxSSSRPP=minGIRPP=maxGIRPP=0
	local dlSubDivs=GISubDivs=noiseBits=minSubdivs=maxSubdivs=globalMult=reflSubDivs=refrSubDivs=SSSSubDivs=subdivsResult=0
	local gBounces=2
	local sBounces=15
	local aAmt = 0.75
	local theWholeNodes=#()
	local numLights=0
	local oldRegion=#()
	local A4V3Node=undefined
	--local touchNodes = True
	local doMaterials = True
	local doLighting = True
	local doSampler = True
	local doCamera = True
	local doVFB = True
	local LCSR = 1.0
	local LCSS = 3.0
	local LCSubdivs
	local LCSSPercent
	if renderers.current.output_getsetsfrommax then
	(	
		LCSubdivs=sqrt(LCSR)*sqrt(renderWidth*renderHeight)
		LCSSPercent=LCSS/sqrt(renderWidth*renderHeight)
	)
	else
	(
		LCSubdivs=sqrt(LCSR)*sqrt(renderers.current.output_width*renderers.current.output_height)
		LCSSPercent=LCSS/sqrt(renderers.current.output_width*renderers.current.output_height)	
	)
	local isArchviz = False
	local TT1=TT2=TT3=TT4=TT5=TT6=TT7=TT8=TT9=TT10=TT11=TT12=TT13=TT14=TT15=TTB1=TTB2=TTB3=TTB4=TTB5=TTB6=TTB7=TTB8=""
	
	/*Tooltips Text*/
	TT1="BASE Glossy Reflection subdivisions: this is not the final amount of samples the renderer will calculate, but rather it's factored in with the AA rays, the GSM and the Adaptive Amount. Check the info panel for the exact number of Samples Per Pixel this value will lead to"
	TT2="BASE Glossy Refraction subdivisions: this is not the final amount of samples the renderer will calculate, but rather it's factored in with the AA rays, the GSM and the Adaptive Amount. Check the info panel for the exact number of Samples Per Pixel this value will lead to"
	TT3="Maximum number of bounces to allow for glossy reflective or refractive shaders: the lower value you can afford without image quality compromises, the faster your render will go"
	TT4="Maximum number of bounces to allow for NON-glossy (ie. one Ray per bounce, very cheap to calculate) reflective or refractive shaders: This isn't typically that critical to render speeds, and is usually best kept quite high"
	TT5="Raytraced Sub-Surface scattering subdivisions. This is an inherently hard parameter to guess before rendering, as the nature of the effect is heavily dependent on the geometry the shader is applied to, as well as to the shader parameters (thickness, bounces and so on), and the intensity of the light shining on it. A good place to start is to match the Glossy Reflection Subdivs, and after a test render check if it needs to be raised or lowered."
	TT6="Direct lighting Subdivisions: This will affect all types of ligth fixtures which have a Vray Shadow property, and its corresponding Subdivs Parameter.(Standard Vray lights, BUT the Dome, all IES ones, and Photometric/Standard Max lights with Vray Shadows enabled)"
	TT7="Image-Based Lighting / Brute Force GI subdivisions: They work in tandem as it makes sense both should be at the same level of sampling, lest noise in one pollutes the other."
	TT8="LC Sample Rate: This expresses the LightCache subdivision as Sample Rate. In other words, when set to 1.0, the script will calculate how many subdivs. the LC should have to make sure one LC sample is cast for each of the image pixels. For general purpose scenarios, 1.0 is a 'sweet spot', with the best tradeoff of calculation time versus quality.It is possible to go above the value, for scenes which have very thin geometric detail, in the order of a a couple of pixels or less, to avoid splotches. Otherwise, turning 'Retrace' on will do just as good, if not a better job of curing light leaks, at the expense of some render time. The info Panel will report how many subdivision a given SR will lead to for a given image size."	
	TT9="LC Sample size in Pixels: This expresses the LC sample size in pixels. In other words, you can choose how big the LC samples will be, regardless of the image size, and the script will calculate the corresponding LC Sample Size as normal fraction (ie. 0.02). The info Panel will report what the usual normal fraction will be for a given pixel size and a given image size."
	TT10="This is the same parameter found in the Global DMC settings panel. It's used in the script to allow for fine tuning of the samples per pixel that will be cast in the image. The info Panel will show realtime information about the exact SPP that will be cast when this will change."
	TT11="This is the same parameter found in the Global DMC settings panel. It's used in the script to allow for fine tuning of the Adaptive samples per pixel that will be cast in the image (the numbers in brackets in the info panel). The lower adaptivity you can afford, the faster the render will trace a given amount of rays, as the rays cast will not have to go through the adaptation routines, but will be cast 'no matter what', which is quicker than double checking them against noise thresholds. WARNING:this set low, coupled with many glossy bounces, could potentially lead to nearly infinite render times. Use ONLY when you are sure you know what you are doing. You have been WARNED! (Twice, at that.) "
	TT12="Noise Sensitivity is the same as Noise Threshold, but expressed as Bits, rather than a float value. The script will calculate the resulting float value as 1.0/2^(noise bits) (ie. 1/256 for 8 bits). As each additional bit allows the expression of a further Stop of brightness (ie. 8 bits: 256 levels, 9 bits: 512, 10 bits:1024 and so on), you should set this accordingly to the expected final render usage. In toher words, if you know the final image will have to be brightened in Post, and by twice the original amount, set this to 9. For general purpose use (ie. Archviz/simple or no post-processing) a value of 8 will be more than enough as that is the amount of bits the usual monitor expresses. Should there be hard-to-clean noise left over, raising the number of bits will force the (adaptive part of the) specialised rays to be cast more often, potentially cleaning the image up without resorting to the ten-fold slower AA rays. The info panel will report the resulting noise threshold as the float value we're all used to."
	TT13="Mix AA subdivs, when the script is used to set up the scene, will MULTIPLY the base shader/lights/GI subdivs by the value put in here. In general, you want to set this value up so that your geometric/texture HIGH FREQUENCY detail, or DoF/MoBlur SILHOUETTE is clean. And then work on the other script parts to precisely set the SHADING samples to get a clean lighting/shading for a given image. Setting both Min and MAx to the same value will shave a little bit of speed as the sampler will not have to check if it needs to step up in AA rays, but it isn't for the faint of heart. MAKE SURE you know what you are doing before going crazy with either of these parameters. Check the info panel to see what happens to your samples while changing this value."	
	TT14="Max AA subdivs, when the script is used to set up the scene, will MULTIPLY the base shader/lights/GI subdivs by the value put in here. In general, you want to set this value up so that your geometric/texture HIGH FREQUENCY detail, or DoF/MoBlur SILHOUETTE is clean. And then work on the other script parts to precisely set the SHADING samples to get a clean lighting/shading for a given image. Setting both Min and MAx to the same value will shave a little bit of speed as the sampler will not have to check if it needs to step up in AA rays, but it isn't for the faint of heart. MAKE SURE you know what you are doing before going crazy with either of these parameters. Check the info panel to see what happens to your samples while changing this value."	
	TT15="With this checked, the script will save the current VFB image in your render history (WARNING:make sure that it's active, and with enough space to save the image!), along with the render region coordinates, and reload (and then delete from the history) that image and the corresponding render area as the new VFB is created. It's meant for a quick and safe way to compare area renders, both noise and time wise. Turning it off will unfortunately wipe the current VFB image as the render settings are reset."
	TTB7="RMC means 'Right-Mouse Click'. Do so and a popup will allow you to save the current script settings with a new name, which you will then be able to recall at will with a LEFT mouse click on the button. Control-RMC the button to delete the preset from the button and your disk."
	TTB8="It's big, It's at the end of the script (unless you read from the bottom up, like most people seem to do on the forums...) and it says 'make scene changes'. How about clicking it to, err, make some changes to the scene? They won't be random changes either, but will accurately reflect the settings you put in the script parts that preceeded the button."
	
	/*Preset Buttons tooltips*/
	TTB1="Meant to render very quickly, and noisily, while giving you an idea of what the final render time will be, as there is a direct, near-linear proportion between the SPP in this preset, and those raised for a final render. "
	TTB2=TTB3="DO NOT USE. WILL CHANGE SOON."
	TTB4="ArchViz scene type preset: thin sheet geo with un-welded, coincident vertices; arbitrarily set shader diffuse and reflectance values coupled with interior shots with many lights, tend to require a lot more sampling to get a clean render. It turns on 'retrace' for the LC. FEEL FREE TO CHANGE THE VALUES TO WHAT IS APPROPRIATE FOR YOUR SHOT. THIS IS NOT A MAGIC TRICK PRESET. I wrote it here, so not to be asked about it in the forums time and again. Take the cue ;)"
	TTB5="VFX scene type preset: very accurately modelled geometry, high quality, physically accurate shaders and lights. Generally, the combination of these factors allows for lower overall SPP. Usable in a vast number of cases where NO DoF or MoBlur is done in camera, due to the lower AA samples."
	TTB6="Same amount of SPP as the previous preset, but higher camera rays, which will help towards cleaning Dof/MoBlur or very fine geometric detail. Notice how the two VFX presets SHOW A CONCEPT: changing camera rays while preserving the overall shading for a given scene. Feel free to set the AA to whatever is needed for a clean SILHOUETTE (checking the alpha channel for moving objects is a good queue as to the quality of your MoBlur.), while correcting the shading part to maintain overall SPP"
	
	fn getNumLights =
	(
		local numLights = 0
		for l in lights where classOf l != targetObject and ((try l.on == true catch false) or (try l.enabled == true catch false))
		do numLights += 1
		numLights
	)
	
	fn changeSubdivs reflSubDivs refrSubDivs dlSubDivs GISubDivs noiseBits SSSSubDivs minSubdivs maxSubdivs gBounces sBounces globalMult aAmt =
	(
		A4V3Node=undefined
		for n in theWholeNodes do
			(
				try
				(
					A4V3Node=n
					if (superClassOf A4V3Node == material) and doMaterials then 		--the node is a material
					(
						print ("Working on " + A4V3Node as string)
						for theProp in (getPropNames A4V3Node) do
							(
	-- 							generic changes
								if  (matchPattern (theProp as string ) pattern:"*cutoff*") do
									(
										cutoffValue=1.0/(2^vr3rpRoll.spn10.value)
										setProperty A4V3Node theProp cutoffValue
										print ("\tSet property " + theProp as string + " to " + cutoffValue as string)
									)
								if  (matchPattern  (theProp as string ) pattern:"*brdf_fixDarkEdges*") do
									(
										setProperty A4V3Node theProp True
										print ("\tSet property " + theProp as string + " to Enabled")
									)
	-- 							standard shaders
								if  (matchPattern  (theProp as string ) pattern:"*refl*subdivs*") do									-- REFLECTION subdivs
									(
										setProperty A4V3Node theProp reflSubDivs
										print ("\tSet property " + theProp as string + " to "+reflSubDivs as string+ " subdivs" )									 
									)
								if  (matchPattern  (theProp as string ) pattern:"*refr*subdivs*") do									-- REFRACTION subdivs
									(
										setProperty A4V3Node theProp refrSubDivs
										print ("\tSet property " + theProp as string + " to "+refrSubDivs as string+ " subdivs" )									 
									)
								if  (matchPattern  (theProp as string ) pattern:"*refl*maxDepth*") do								--REFLECTION gBounces/sBounces
									(
											if (A4V3Node.reflection_glossiness < 1 or (A4V3Node.texmap_reflectionGlossiness != undefined and A4V3Node.texmap_reflectionGlossiness_on) ) then
												(
													setProperty A4V3Node theProp gBounces
													print ("\tSet property " + theProp as string + " to " + gBounces as string)
												)
											else 
												(
													setProperty A4V3Node theProp sBounces
													print ("\tSet property " + theProp as string + " to " + sBounces as string)											
												)
									)
								if  (matchPattern  (theProp as string ) pattern:"*refr*maxDepth*") do								--REFRACTION gBounces/sBounces
									(
										if (A4V3Node.refraction_glossiness < 1 or (A4V3Node.texmap_refractionGlossiness != undefined and A4V3Node.texmap_refractionGlossiness_on) ) then
											(
												setProperty A4V3Node theProp gBounces
												print ("\tSet property " + theProp as string + " to " + gBounces as string)
											)
										else 
											(
												setProperty A4V3Node theProp sBounces
												print ("\tSet property " + theProp as string +" to " + sBounces as string)											
											)
									)									
	-- 							SSS types	
								if  (matchPattern  (theProp as string ) pattern:"*multiple_scattering*") do
									(
										setProperty A4V3Node theProp 2
										print ("\tSet property " + theProp as string + " to Raytraced")
									)
								if  (matchPattern  (theProp as string ) pattern:"*scatter*subdivs*") do
									(
										setProperty A4V3Node theProp SSSSubdivs
										print ("\tSet property " + theProp as string + " to " + SSSSubdivs as string)
									)
								if  (matchPattern  (theProp as string ) pattern:"*raytraced*subdivs*") do
									(
										setProperty A4V3Node theProp SSSSubdivs
										print ("\tSet property " + theProp as string + " to " + SSSSubdivs as string)
									)								
							)
					)
					else if doLighting do												--the node is a light
					(
						for theProp in (getPropNames A4V3Node) do
							(
								if  (matchPattern  (theProp as string ) pattern:"*subdivs*")!=False do				--the light has a "subdivs" parameter
									(
										if classof A4V3Node==VRayLight and A4V3Node.type==1 then 					--dome light
											(
												execute ("$"+A4V3Node.name+"."+theProp +"="+GISubDivs as string)
											)
										else																		--NOT a dome light. may be standard, ies or vray Area
											(
												if subdivsResult!=0 then 
												(
													execute ("$"+A4V3Node.name+"."+theProp +"="+subdivsResult as string)
												)
												else
												(
													execute ("$"+A4V3Node.name+"."+theProp +"="+dlSubDivs as string)
												)
											)
										print ("\tSet property " + theProp as string + " to " + dlSubDivs as string + " subdivs")
									)
								if  (matchPattern  (theProp as string ) pattern:"*cutoff*")!=False do
									(
										execute ("$"+A4V3Node.name+"."+theProp +"=1.0/(2^vr3rpRoll.spn10.value)")
										print ("\tSet property " + theProp as string + " to " + (1.0/(2^vr3rpRoll.spn10.value)) as string )
									)
							)
					)
				)
				catch
				(
					print ("Failed for " + n as string)
				)
			)
	)

	fn setRenderSettings =
	(
		if doSampler or doCamera do
		(
			local rsa=#()
			rsa = lf.parseEnvironmentSettings True True True True True True True True True
			if doVFB do
			(
				print "Storing VRay FB data"
				wasRR=vrayVFBGetRegionEnabled()
				oldRegion=vrayVFBGetRegion()
				vfbControl #historysave
			)
			lf.resetVray()
			lf.restoreEnvironmentSettings rsa	
			local rdWasOpen=lf.closeRendDiag()
			if doVFB do
			(
				print "ReStoring VRay FB data"
				vfbControl #history true
				vfbControl #historySelect 0
				vfbControl #historyLoad
				vfbControl #historySelect 0
				vfbControl #historyRemove
				vrayVFBSetRegionEnabled wasRR
				vrayVFBSetRegion oldRegion[1] oldRegion[2] oldRegion[3] oldRegion[4]
			)
			cr=renderers.current
			if doVFB do
			(
				cr.showLastVFB()
			)
			
			/*  GI  Setup */
			cr.gi_on= true
			cr.gi_primary_type=2
			cr.gi_secondary_type=3
			cr.lightcache_subdivs=LCSubdivs
			cr.lightcache_sampleSize=LCSSPercent
			if 	isArchviz then 
			(
				cr.lightcache_prefilter_on =  true
				cr.lightcache_prefilter_samples = 100
				cr.lightcache_filter_type=0
				cr.lightcache_retrace_on= True			
			)
			else
			(
				cr.lightcache_prefilter_on =  true
				cr.lightcache_prefilter_samples = 25
				cr.lightcache_filter_type=0
			)
			if doSampler do
			(
				cr.mcgi_subdivs=GISubDivs
				cr.system_embree_on = true
				cr.system_raycaster_memLimit = 0
				print ("---------------------> noise bits: "+ noiseBits as string)
				cr.mc_earlyTermination_threshold=1.0/(2^noiseBits)
				cr.dmc_timeDependent=True
				cr.options_ray_bias=0.0001
				cr.options_probabilisticLights=False
				--cr.options_maxRayIntensity_on=False
				cr.mc_subdivs_mult=globalMult
				cr.dmc_earlyTermination_amount=aAmt	
			)
			if doCamera do
			(
				cr.filter_on=False
				cr.dmc_balanceSubdivs=false
				cr.imageSampler_type=1
				cr.twoLevel_baseSubdivs=minSubdivs
				cr.twoLevel_fineSubdivs=maxSubdivs
				cr.twoLevel_showSamples=False
				cr.twoLevel_useMCSamplerThresh=False
				cr.twoLevel_threshold=1.0/256
			)
			lf.openRendDiag rdWasOpen
		)
	)
	
	rollout vr3rpRoll "Vray3RenderMate V 1.50R" width:424 height:776
	(
		local vr3rpRoll
		local presetNumber
		
		GroupBox grp1 "Settings:" pos:[8,8] width:408 height:336
		
		GroupBox grp2 "Shaders:" pos:[16,24] width:392 height:96
		checkbox chk1 "" pos:[80,24] width:16 height:16 checked:true
		label lbl1 "Glossy Refl. Subdivs:" pos:[24,48] width:128 height:16	
		spinner spn1 "" pos:[152,48] width:56 height:16 range:[1,1024,16] type:#integer scale:1	tooltip:TT1
		label lbl2 "Glossy Refr. Subdivs:" pos:[216,48] width:128 height:16
		spinner spn2 "" pos:[344,48] width:56 height:16 range:[1,1024,16] type:#integer scale:1 tooltip:TT2
		label lbl3 "Glossy Bounces:" pos:[24,72] width:128 height:16
		spinner spn3 "" pos:[152,72] width:56 height:16 range:[1,1024,3] type:#integer scale:1 tooltip:TT3
		label lbl4 "Straight Bounces:" pos:[216,72] width:128 height:16
		spinner spn4 "" pos:[344,72] width:56 height:16 range:[1,1024,15] type:#integer scale:1 tooltip:TT4
		label lbl5 "SSS Subdivs:" pos:[24,96] width:128 height:16
		spinner spn5 "" pos:[152,96] width:56 height:16 range:[1,1024,12] type:#integer scale:1 tooltip:TT5
		
		GroupBox grp4 "Lighting:" pos:[16,128] width:392 height:72
		checkbox chk2 "" pos:[80,128] width:16 height:16 checked:true
		label lbl6 "Direct Lighting Subdivs:" pos:[24,152] width:128 height:16 
		spinner spn6 "" pos:[152,152] width:56 height:16 range:[1,1024,16] type:#integer scale:1 tooltip:TT6
		label lbl7 "IBL/BF GI Subdivs:" pos:[216,152] width:128 height:16 
		spinner spn7 "" pos:[344,152] width:56 height:16 range:[1,1024,24] type:#integer scale:1 tooltip:TT7
		label lbl27 "LC Sample Rate:" pos:[24,176] width:128 height:16
		spinner spn13 "" pos:[152,176] width:56 height:16 range:[0.01,1024,1] type:#float scale:0.01 tooltip:TT8
		label lbl28 "LC Sample Size (Px):" pos:[216,176] width:128 height:16
		spinner spn14 "" pos:[344,176] width:56 height:16 range:[0.001,1024,3] type:#float scale:0.01 tooltip:TT9
		
		GroupBox grp5 "General Sampling Behaviour:" pos:[16,208] width:392 height:72
		checkbox chk3 "" pos:[168,208] width:16 height:16 checked:true
		label lbl8 "Global Subdivs Mult:" pos:[24,232] width:128 height:16
		spinner spn8 "" pos:[152,232] width:56 height:16 range:[0,1024,1] type:#float scale:0.001 tooltip:TT10
		label lbl9 "Sampling Adaptive Amt.:" pos:[216,232] width:128 height:16
		spinner spn9 "" pos:[344,232] width:56 height:16 range:[0,100,0.75] type:#float scale:0.001 tooltip:TT11
		label lbl10 "Noise Sens. (Bits):" pos:[24,256] width:128 height:16
		spinner spn10 "" pos:[152,256] width:56 height:16 range:[1,32,8] type:#integer scale:1 tooltip:TT12
		
		GroupBox grp6 "Camera Sampling Behaviour:" pos:[16,288] width:392 height:48	
		checkbox chk4 "" pos:[168,288] width:16 height:16 checked:true	
		label lbl11 "Min AA Subdivs:" pos:[24,312] width:128 height:16
		spinner spn11 "" pos:[152,312] width:56 height:16 range:[1,1024,2] type:#integer scale:1 tooltip:TT13
 		label lbl12 "Max AA Subdivs:" pos:[216,312] width:128 height:16
		spinner spn12 "" pos:[344,312] width:56 height:16 range:[1,1024,4] type:#integer scale:1 tooltip:TT14

		GroupBox grp7 "Resulting Info:" pos:[8,352] width:408 height:232
		label lbl13 "" pos:[16,372] width:392 height:208

		GroupBox grp8 "Easy Presets:" pos:[8,596] width:408 height:48
		button btn1 "Rough" pos:[10,612] width:64 height:24 tooltip:TTB1
		button btn2 "Clean (D)" pos:[78,612] width:64 height:24 tooltip:TTB2
		button btn3 "2Stops" pos:[146,612] width:64 height:24 tooltip:TTB3
		button btn4 "ArchViz" pos:[214,612] width:64 height:24 tooltip:TTB4
		button btn5 "VFX-Std" pos:[282,612] width:64 height:24 tooltip:TTB5
		button btn6 "VFX-Cmplx" pos:[350,612] width:64 height:24 tooltip:TTB6
		
		GroupBox grp9 "User Presets:" pos:[8,652] width:408 height:48
		button uBtn1 "RMC me!" pos:[10,668] width:64 height:24 tooltip:TTB7
		button uBtn2 "RMC me!" pos:[78,668] width:64 height:24 tooltip:TTB7
		button uBtn3 "RMC me!" pos:[146,668] width:64 height:24 tooltip:TTB7
		button uBtn4 "RMC me!" pos:[214,668] width:64 height:24 tooltip:TTB7
		button uBtn5 "RMC me!" pos:[282,668] width:64 height:24 tooltip:TTB7
		button uBtn6 "RMC me!" pos:[350,668] width:64 height:24 tooltip:TTB7
		
		GroupBox grp10 "aaaaand, Action!" pos:[8,708] width:408 height:56		
		button executeBtn "Make Scene Changes" pos:[16,724] width:264 height:32 tooltip:TTB8
		checkbox chk5 "Checkbox" pos:[390,728] width:18 height:16 checked:true  tooltip:TT15
		label lbl29 "Store/Restore VFB" pos:[288,728] width:96 height:16
		

/*							Various functions for rollout Behavior				*/
		fn refreshUserLabels=
		(
			local theUserButtonNumber,theLabel
			presetPath = getDir #plugCfg + @"\A4V3_Preset_Files\"
			theFiles=getFiles (presetPath+"*.txt")

			for f in theFiles do
			(
				theUserButtonNumber = getFilenameFile f
				theFile=openFile f mode:"r"
				seek theFile 0
				theLabel=readLine theFile
				close theFile
				theString = ("vr3rpRoll.uBtn"+ theUserButtonNumber +".caption=\"" + theLabel +"\"")
				execute theString
			)
		)
		
		fn applyUserPreset=
		(
			local theLabel
			presetPath = getDir #plugCfg + @"\A4V3_Preset_Files\"
			theFileName=(presetPath+presetNumber+".txt")
			if doesFileExist theFileName then 
			(
				theFile=openFile theFileName mode:"r"
				seek theFile 0
				presetName=readLine theFile
				while not (eof theFile) do
				(
					theLine=readLine theFile
					theWholeLine="vr3rpRoll."+theLine
					execute theWholeLine
				)
				close theFile
				print ("Applied preset number " + presetNumber + " named '" + presetName +"'")
			)
			else
			(
				messageBox "No Preset File Saved for this button!"
			)
		)

		fn popDialog=
		(
			rollout presetNameRoll "Preset Name:" width:184 height:32
			(
				editText presetNameEdt "" pos:[8,8] width:128 height:16
				button presetSaveBtn "Save" pos:[144,8] width:32 height:16

				on presetSaveBtn pressed do
				(
					presetPath = getDir #plugCfg + @"\A4V3_Preset_Files\"
					makeDir presetPath
					presetName = (presetNumber as string)
					valuePairArray=#()
					
					for c in (execute("vr3rpRoll.controls")) where classof c == SpinnerControl do
						(
							append valuePairArray #((c.name+".value"),c.value)
						)
					for c in (execute("vr3rpRoll.controls")) where classof c == CheckBoxControl do
						(
							append valuePairArray #((c.name+".checked"),c.checked)
						)						
					presetFilename = presetPath + presetName + ".txt"
					thePresetFile = openFile presetFilename mode:"w+"
					format "%\n" presetNameEdt.text to:thePresetFile
					for p in valuePairArray do
						format "%=%\n" p[1] p[2] to:thePresetFile
					close thePresetFile
								
					destroyDialog presetNameRoll
					refreshUserLabels()
				)
				
			)
			createDialog presetNameRoll
		)
		
		fn deletePreset=
		(
			presetPath = getDir #plugCfg + @"\A4V3_Preset_Files\"
			presetName = (presetNumber as string)
			presetFilename = presetPath + presetName + ".txt"
			if (deleteFile presetFilename) then
			(
				print ("Deleted preset number " + presetNumber)
				theString = ("vr3rpRoll.uBtn"+ presetNumber +".caption=\"RMC me!\"")
				execute theString
			)
			else
			(
				messageBox ("Something went wrong trying to delete the preset file from disk,\nor no preset was saved for this button.\n"+presetFilename)
			)
		)
		
		fn refreshVarsVals =
		(
			reflSubDivs=spn1.value
			refrSubDivs=spn2.value
			gBounces=spn3.value			
			sBounces=spn4.value
			
			SSSSubDivs=spn5.value
			
			dlSubDivs=spn6.value
			GISubDivs=spn7.value
			
			globalMult=spn8.value
			aAmt=spn9.value			
			noiseBits=spn10.value
	
			minSubdivs=spn11.value
			maxSubdivs=spn12.value
			
			LCSR = spn13.value
			LCSS = spn14.value

		)		

		fn updateInfoLabel =
		(
			numLights=getNumLights()
			refreshVarsVals()

			minRPP=maxRPP=( (reflSubDivs^2)*globalMult ) as integer
			lightsMinRPP=lightsMaxRPP=( (dlSubDivs^2)*globalMult ) as integer
			minShCPP=( ((reflSubDivs*minSubdivs)^2 )*globalMult)  as integer
			maxShCPP=( ((reflSubDivs*maxSubdivs)^2 )*globalMult)  as integer
			minLtCPP=( ((dlSubDivs*minSubdivs)^2 )*globalMult) as integer
			maxLtCPP=( ((dlSubDivs*maxSubdivs)^2 )*globalMult) as integer
			SSSRPP=( ((SSSSubDivs)^2 )*globalMult) as integer
			minSSSRPP= ( ((SSSSubDivs*minSubdivs)^2 )*globalMult)  as integer
			maxSSSRPP= ( ((SSSSubDivs*maxSubdivs)^2 )*globalMult)  as integer
			GIRPP=( ((GISubDivs)^2 )*globalMult) as integer
			minGIRPP=( ((GISubDivs*minSubdivs)^2 )*globalMult)  as integer
			maxGIRPP=( ((GISubDivs*maxSubdivs)^2 )*globalMult)  as integer
			if renderers.current.output_getsetsfrommax then
			(	
				LCSubdivs=sqrt(LCSR)*sqrt(renderWidth*renderHeight)
				LCSSPercent=LCSS/sqrt(renderWidth*renderHeight)
			)
			else
			(
				LCSubdivs=sqrt(LCSR)*sqrt(renderers.current.output_width*renderers.current.output_height)
				LCSSPercent=LCSS/sqrt(renderers.current.output_width*renderers.current.output_height)	
			)
			
			if (minShCPP>2101514800 or minShCPP < 0 )then minShCPP="LOADS!"
			if (maxShCPP>2101514800 or maxShCPP < 0 ) then maxShCPP="LOTS!"
			
			lbl13.caption="\t\t\t\tfixed\t|(max adaptive)\n"	
			lbl13.caption+=("Base Shaders Samples :\t\t" + ((minRPP * (1-aAmt)) as integer ) as string +"\t|("+ minRPP as string + ")\n")
			lbl13.caption+=("Base SSS Samples :  \t\t" + ((SSSRPP * (1-aAmt)) as integer)as string +"\t|("+SSSRPP as string + ")\n")
			lbl13.caption+=("Base Lights Samples :\t\t" + ((lightsMinRPP * (1-aAmt)) as integer) as string +"\t|("+lightsMinRPP as string + ")\n")
			lbl13.caption+=("Base IBL/GI Samples :\t\t" + ((GIRPP * (1-aAmt)) as integer)as string +"\t|("+GIRPP as string + ")\n")					
			lbl13.caption+=("Camera (AA) Samples:\t\t" + (spn11.value^2) as string + "\t|(" + (spn12.value^2) as string +")\n")
			lbl13.caption+=("Resulting Noise Threshold:\t" + (1.0/(2^noiseBits)) as string +"\n")
			lbl13.caption+="--------------------------------------------------------------------------------------------------\n"
			lbl13.caption+="\t\t\tmin fixed|(min adaptive)\t/max fixed|(max adaptive)\n"	
			lbl13.caption+=("Total Shaders Samples: \t\t" + ((minShCPP * (1-aAmt)) as integer)as string + "|("+minShCPP as string +")\t/"+ ((maxShCPP * (1-aAmt)) as integer)as string +"|("+maxShCPP as string+")\n")
			lbl13.caption+=("Total SSS Samples: \t\t" + ((minSSSRPP * (1-aAmt)) as integer)as string + "|("+minSSSRPP as string +")\t/"+ ((maxSSSRPP * (1-aAmt)) as integer)as string +"|("+maxSSSRPP as string+")\n")
			lbl13.caption+=("Total Lights Samples: \t\t" + ((minLtCPP * (1-aAmt)) as integer)as string + "|("+minLtCPP as string +")\t/"+ ((maxLtCPP * (1-aAmt)) as integer)as string +"|("+maxLtCPP as string+")\n")
			lbl13.caption+=("Total IBL/GI Samples: \t\t" + ((minGIRPP * (1-aAmt)) as integer)as string + "|("+minGIRPP as string +")\t/"+ ((maxGIRPP * (1-aAmt)) as integer)as string +"|("+maxGIRPP as string+")\n")
			lbl13.caption+="--------------------------------------------------------------------------------------------------\n"
			lbl13.caption+=("Current LC subdivs :\t" + int(LCSubdivs) as string + "\tCurrent LC Sample Size % :\t" + LCSSPercent as string +"\n")
			lbl13.caption+=("Total Number Of Active Lights :\t" + numLights as string + "\n")
			
		)


/*							Various Behaviors for rollout components				*/		
		
			
		

		on vr3rpRoll open do
		(
			updateInfoLabel()
			refreshUserLabels()
		)
		on spn1 changed val do
			updateInfoLabel()
		on spn2 changed val do
			updateInfoLabel()
		on spn3 changed val do
			updateInfoLabel()
		on spn4 changed val do
			updateInfoLabel()
		on spn5 changed val do
			updateInfoLabel()
		on spn6 changed val do
			updateInfoLabel()
		on spn7 changed val do
			updateInfoLabel()
		on spn8 changed val do
			updateInfoLabel()
		on spn9 changed val do
			updateInfoLabel()
		on spn10 changed val do
			updateInfoLabel()
		on spn11 changed val do
			updateInfoLabel()
		on spn12 changed val do
			updateInfoLabel()
		on spn13 changed val do
			updateInfoLabel()
		on spn14 changed val do
			updateInfoLabel()			

		on btn1 pressed do
		(
			spn1.value = spn2.value = spn5.value = spn6.value = spn7.value = spn11.value = spn12.value = 2
			spn3.value = 3
			spn4.value = 15			
			spn8.value = 1
			spn9.value = 0.925
			spn10.value = 5
			spn13.value= 1.0
			spn14.value= 5.0
			isArchviz = False			
			updateInfoLabel()
		)
		on btn2 pressed do
		(
			spn1.value = spn2.value = spn6.value = 16
			spn3.value = spn11.value = 2
			spn4.value = 15
			spn5.value = 12
			spn7.value = 24
			spn8.value = 1
			spn9.value = 0.75
			spn10.value = 8
			spn12.value = 4
			spn13.value= 1.0
			spn14.value= 5.0
			isArchviz = False			
			updateInfoLabel()
		)
		on btn3 pressed do
		(
			spn1.value = spn2.value = spn6.value = 24
			spn3.value = spn11.value = 2
			spn4.value = 15
			spn5.value = 20
			spn7.value = 32
			spn8.value = 0.889
			spn9.value = 0.75
			spn10.value = 10
			spn12.value = 4
			spn13.value= 1.0
			spn14.value= 3.0
			isArchviz = False
			updateInfoLabel()
		)
		on btn4 pressed do		--ArchViz
		(
			spn1.value = spn2.value = spn5.value = 11
			spn3.value = 3
			spn4.value = 15
			spn6.value = 8
			spn7.Value = 12
			spn8.value = 2.0
			spn9.value = 0.5			
			spn10.value = 12
			spn11.value = 4
			spn12.value = 5
			spn13.value= 1
			spn14.value= 5.0
			isArchviz = True
			updateInfoLabel()
		)
		on btn5 pressed do		--VFX-Std
		(
			spn1.value = spn2.value = spn5.value = spn6.value = spn7.value = 2
			spn3.value = 3
			spn4.value = 15
			spn8.value = 32
			spn9.value = 0.625			
			spn10.value = 12
			spn11.value = spn12.value = 4
			spn13.value= 2.0
			spn14.value= 3.0	
			isArchviz = False			
			updateInfoLabel()
		)
		on btn6 pressed do		--VFX-Cmplx
		(
			spn1.value = spn2.value = spn5.value = spn6.value = spn7.value = 2
			spn3.value = 3
			spn4.value = 15
			spn8.value = 2
			spn9.value = 0.625			
			spn10.value = 12
			spn11.value = spn12.value = 16
			spn13.value= 2.0
			spn14.value= 3.0
			isArchviz = False			
			updateInfoLabel()
		)
		on uBtn1 pressed do
		(
			presetNumber="1"
			applyUserPreset()
			updateInfoLabel()
		)
		on uBtn1 rightClick do
		(
			print "clicked!"
			presetNumber="1"
			if keyboard.controlPressed then 
			(
				deletePreset()
			)	
			else
			(
				popDialog()
			)
		)
		on uBtn2 pressed do
		(
			presetNumber="2"
			applyUserPreset()
			updateInfoLabel()
		)
		on uBtn2 rightClick do
		(
			print "clicked!"
			presetNumber="2"
			if keyboard.controlPressed then 
			(
				deletePreset()
			)	
			else
			(
				popDialog()
			)
		
		)
		on uBtn3 pressed do
		(
			presetNumber="3"
			applyUserPreset()
			updateInfoLabel()
		)
		on uBtn3 rightClick do
		(
			print "clicked!"
			presetNumber="3"
			if keyboard.controlPressed then 
			(
				deletePreset()
			)	
			else
			(
				popDialog()
			)
		)
		on uBtn4 pressed do
		(
			presetNumber="4"
			applyUserPreset()
			updateInfoLabel()
		)
		on uBtn4 rightClick do
		(
			print "clicked!"
			presetNumber="4"
			if keyboard.controlPressed then 
			(
				deletePreset()
			)	
			else
			(
				popDialog()
			)
		)
		on uBtn5 pressed do
		(
			presetNumber="5"
			applyUserPreset()
			updateInfoLabel()
		)
		on uBtn5 rightClick do
		(
			print "clicked!"
			presetNumber="5"
			if keyboard.controlPressed then 
			(
				deletePreset()
			)	
			else
			(
				popDialog()
			)
		)
		on uBtn6 pressed do
		(
			presetNumber="6"
			applyUserPreset()
			updateInfoLabel()
		)
		on uBtn6 rightClick do
		(
			print "clicked!"
			presetNumber="6"
			if keyboard.controlPressed then 
			(
				deletePreset()
			)	
			else
			(
				popDialog()
			)
		)
		on chk1 changed theState do
			doMaterials = theState
		on chk2 changed theState do
			doLighting = theState
		on chk3 changed theState do
			doSampler = theState
		on chk4 changed theState do
			doCamera = theState
		on chk5 changed theState do
			doVFB = theState

		
		
		on executeBtn pressed do
		(
		
			updateInfoLabel()
			theWholeNodes=#()
			if doMaterials do 
			(
				for m in scenematerials do append theWholeNodes m
				join theWholeNodes (getClassInstances VrayMtl)
				join theWholeNodes (getClassInstances VrayFastSSS2)
				join theWholeNodes (getClassInstances VrayLightMtl)
				join theWholeNodes (getClassInstances VraySkinMtl)
				join theWholeNodes (getClassInstances VrayCarPaintMtl)
				join theWholeNodes (getClassInstances VrayHairMtl)
				join theWholeNodes (getClassInstances VrayOSLMtl)
				join theWholeNodes (getClassInstances VrayScatterVolume)
			)
			if doLighting do
			(
				for l in lights where classof l != targetObject do append theWholeNodes l
			)
		-- 			print theWholeNodes
			if theWholeNodes.count != 0 do
			(
				theWholeNodes=makeUniqueArray theWholeNodes
		-- 			print theWholeNodes
				changeSubdivs reflSubDivs refrSubDivs dlSubDivs GISubDivs noiseBits SSSSubDivs minSubdivs maxSubdivs gBounces sBounces globalMult aAmt
			)
			
			setRenderSettings()
		)

	)
	
	
	
	createdialog vr3rpRoll style:#(#style_titlebar, #style_border, #style_sysmenu,#style_minimizebox,#style_maximizebox)

	
	
	
)
